

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Math, Grids, ExtDlgs, ExtCtrls, Menus, ComCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    DrawGrid1: TDrawGrid;
    Edit1: TEdit;
    Label3: TLabel;
    Image1: TImage;
    CheckBox1: TCheckBox;
    OpenPictureDialog1: TOpenPictureDialog;
    Button1: TButton;
    Button2: TButton;
    Label7: TLabel;
    Label8: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Label9: TLabel;
    Edit6: TEdit;
    Label10: TLabel;
    OpenProjectDialog: TOpenDialog;
    SaveProjectDialog: TSaveDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Label12: TLabel;
    N3: TMenuItem;
    CheckBox4: TCheckBox;
    Label13: TLabel;
    N4: TMenuItem;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    Button5: TButton;
    procedure DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormCreate(Sender: TObject);
    procedure DrawGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Edit5Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure DrawGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DrawGrid1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);

    // I^Cgň͂
    procedure DrawFrameTile;

    // ObhYTCYύX
    procedure ChangeMapSizeY;
    // ObhXTCYύX
    procedure ChangeMapSizeX;

    // C[W̓ǂݍ
    procedure LoadImage;

    // ֘AtÑvWFNgǂݍ
    procedure NewOpenProject;
    procedure CheckBox4Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    // vWFNg㏑ۑ
    procedure SaveUpdateProject;
    // Iz̃TCY\
    procedure ShowArraySize;

    procedure N4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);


  private
    { Private 錾 }
  public
    { Public 錾 }

    ArrayName : String; // o͂z̖O

  // }bvf[^z
  MapTable : Array of Array of Word;

  Map_X : Integer; // }bv̉TCY
  Map_y : Integer; // }bv̏cTCY

  Select_tile : Integer; // I^Cԍ

  TileBMP: TPicture; // ǂݍ񂾉摜̕ۊǗp

  Image_Tile_X : Integer; // 摜̉̃^C

  isMouseDown : Boolean; // }EX{^Ă邩

  LoadImagePath : String; // ǂݍ񂾉摜t@CpX

  ProjectFilePath : String; // vWFNgt@C̃pX

  isChanged : Boolean; // OۑĂ瑀삵


  end;

var

  // tH[
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}



// I^Cgň͂
procedure TForm1.DrawFrameTile;
var
  MyCanvas:TCanvas;

begin

  With Form1 do
  begin
	if TileBMP.Bitmap.Empty = False then
        begin

            //Image1.Repaint;
            Image1.Picture.Bitmap := TileBMP.Bitmap;
            MyCanvas := Image1.Canvas;

            MyCanvas.Brush.Color := clBlack;

            // Ïgň͂
            MyCanvas.FrameRect(Classes.Rect(

            	Select_Tile mod Image_Tile_X*8,
                Select_Tile div Image_Tile_X*8,

            	((Select_Tile mod Image_Tile_X)+StrToInt(Edit5.Text))*8,
                ((Select_Tile div Image_Tile_X)+StrToInt(Edit6.Text))*8

                ));
        end;
     end;
end;


// h[ObhEZ̕`
procedure TForm1.DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);

var
	MyCanvas:TCanvas;

begin

        MyCanvas := DrawGrid1.Canvas;

        // sEԍ̕\
        if gdFixed in State then
        begin

            MyCanvas.Pen.Color := clBlack;

            if Acol = 0 then
            begin
            	if Arow <> 0 then
            	MyCanvas.TextOut(Rect.Left+1, Rect.Top+2, IntToStr(Arow-1));
            end
            else if Arow = 0 then
            begin
                MyCanvas.TextOut(Rect.Left+1, Rect.Top+2, IntToStr(Acol-1));
            end;
        end

        // ^C̕`
        else
        begin
            if TileBMP.Bitmap.Empty = False then
            begin
                   MyCanvas.CopyRect(
                    	Rect,
                        TileBMP.Bitmap.Canvas,
                        Classes.Rect(
                        	(MapTable[Arow-1][Acol-1] mod Image_Tile_X)*8+0,
                                (MapTable[Arow-1][Acol-1] div Image_Tile_X)*8+0,

                                (MapTable[Arow-1][Acol-1] mod Image_tile_X)*8+8,
                                (MapTable[Arow-1][Acol-1] div Image_Tile_X)*8+8)
                        );

            end;
            if CheckBox4.Checked then
            begin
                // ^Cԍ̕\
            	MyCanvas.Pen.Color := clBlack;
            	MyCanvas.MoveTo(Rect.Right-1,Rect.Top);
                MyCanvas.LineTo(Rect.Right-1,Rect.Bottom-1);
                MyCanvas.LineTo(Rect.Left,Rect.Bottom-1);

            end;
            if CheckBox1.Checked then
            begin
                // ^Cԍ̕\
            	MyCanvas.Pen.Color := clBlack;
            	MyCanvas.TextOut(Rect.Left+1, Rect.Top+2, IntToStr(MapTable[Arow-1][Acol-1]));

            end;
        end;

end;


// ֘AtÑvWFNgǂݍ
procedure TForm1.NewOpenProject;
var

  F: TextFile;
  S: string;
  x,y : Integer;

begin

	// vONɈnĂ
	if FileExists(ParamStr(1)) then
    begin

    	AssignFile(F, ParamStr(1));
    	Reset(F);

    	Readln(F,LoadImagePath);
    	Readln(F,ArrayName);

    Readln(F,s);
    Form2.Edit2.Text := s;
    Map_X := StrToInt(s);

    Readln(F,s);
    Form2.Edit3.Text := s;
    Map_Y := StrToInt(s);

    SetLength(MapTable,Map_Y,Map_X);
    ShowArraySize;

    for y := Low(MapTable) to High(MapTable) do
		for x := Low(MapTable[y]) to High(MapTable[y]) do
           Readln(F,MapTable[y][x]);

    CloseFile(F);

    ProjectFilePath := OpenProjectDialog.Filename;

    LoadImage;

    ChangeMapSizeX;
    ChangeMapSizeY;

    DrawFrameTile;
    DrawGrid1.Repaint;

    isChanged := false;

    end;

end;


// tH[Ƃ̏ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin

    Map_X := 32;
    Map_Y := 32;

    SetLength(MapTable,Map_Y,Map_X);

    ArrayName := 'Default';

    DrawGrid1.ColCount := Map_X + 1;
    DrawGrid1.RowCount := Map_Y + 1;

    TileBMP := TPicture.Create;

    Select_tile := 1;
    Image_Tile_X := 0;

    isChanged := false;

    NewOpenProject;

 //   ShowArraySize;

end;

// }bvɃZzu
procedure TForm1.DrawGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);

var
	x,y : Integer;
        height,width : Integer;
        tile_index : Integer;

begin

	height := StrToInt(Edit6.Text);
    width := StrToInt(Edit5.Text);


        // ͈̓^CΉ
        for y := 0 to height-1 do
        begin
          for x := 0 to width-1 do
          begin

             tile_index := Select_tile + x + Image_Tile_X*y;

             if Acol-1+x > Map_X-1 then Continue;
             if Arow-1+y > Map_Y-1 then Continue;
             if Acol-1+x > Map_X-1 then Continue;
             if Arow-1+y > Map_Y-1 then Continue;

             if tile_index >= (Image1.Width div 8) * (Image1.Height div 8) then Break;

             MapTable[Arow-1+y][Acol-1+x] := tile_index;

          end;
        end;

       //    DrawGrid1.Repaint;
       isChanged := true;

end;

// 摜ǂݍ
procedure TForm1.LoadImage;
begin

        TileBMP.Bitmap.LoadFromFile(LoadImagePath);

        Image1.Picture.Bitmap := TileBMP.Bitmap;

        Image1.Width := TileBMP.Width;
        Image1.Height := TileBMP.Height;

        Image_Tile_X := Image1.Width div 8;
        Edit4.Text := IntToStr(Image_Tile_X);

        isChanged := true;

end;


// 摜̓ǂݍ
procedure TForm1.Button1Click(Sender: TObject);
begin

	if OpenPictureDialog1.Execute then
    begin
        LoadImagePath := OpenPictureDialog1.FileName;

        LoadImage;
        DrawFrameTile;
        DrawGrid1.Repaint;

    end;
end;

// }bvŃ^Cԍ\邩̐ݒύX
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
	DrawGrid1.Repaint;
end;

// ObhXTCYύX
procedure TForm1.ChangeMapSizeX;
begin

    if StrToInt(Form2.Edit2.Text) > 4096 then Form2.Edit2.Text := IntToStr(4096);

	Map_X := StrToInt(Form2.Edit2.Text);

    SetLength(MapTable,Map_Y,Map_X);
	ShowArraySize;

    DrawGrid1.ColCount := Map_X + 1;

    isChanged := true;

end;

// ObhYTCYύX
procedure TForm1.ChangeMapSizeY;
begin

    if StrToInt(Form2.Edit3.Text) > 4096 then Form2.Edit3.Text := IntToStr(4096);

	Map_Y := StrToInt(Form2.Edit3.Text);

    SetLength(MapTable,Map_Y,Map_X);
	ShowArraySize;

    DrawGrid1.RowCount := Map_Y + 1;

    isChanged := true;

end;


// I^CœhԂ
procedure TForm1.Button2Click(Sender: TObject);
var
	x,y:Integer;
begin

    for y := Low(MapTable) to High(MapTable) do
		for x := Low(MapTable[y]) to High(MapTable[y]) do
    		MapTable[y][x] := Select_tile;

    DrawGrid1.Repaint;

end;

// I^CύX
procedure TForm1.Edit1Exit(Sender: TObject);
begin
	Select_tile := StrToInt(Edit1.Text);
end;


// ^CI
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

	Select_tile := X div 8 + (Y div 8 * Image_Tile_X);
	Edit1.Text := IntToStr(Select_tile);

	DrawFrameTile;

end;


procedure TForm1.Edit5Change(Sender: TObject);
begin

	DrawFrameTile;
end;

procedure TForm1.Edit6Change(Sender: TObject);
begin

	DrawFrameTile;
end;



procedure TForm1.DrawGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
		isMouseDown := TRUE;
end;

procedure TForm1.DrawGrid1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
        isMouseDown := FALSE;
        DrawGrid1.Repaint;
end;


// vWFNgۑ
procedure TForm1.N1Click(Sender: TObject);
var

  F: TextFile;
  S: string;
  x,y : Integer;
begin
	//
    if SaveProjectDialog.Execute = False then Exit;

    AssignFile(F, SaveProjectDialog.Filename);
    Rewrite(F);

    Writeln(F,LoadImagePath);
    Writeln(F,ArrayName);

    s := Form2.Edit2.Text;
    Writeln(F,s);

    s := Form2.Edit3.Text;
    Writeln(F,s);

    for y := Low(MapTable) to High(MapTable) do
		for x := Low(MapTable[y]) to High(MapTable[y]) do
        begin
           s := IntToStr(MapTable[y][x]);
           Writeln(F,s);
    	end;


    CloseFile(F);

    isChanged := false;

end;

// vWFNgǂݍ
procedure TForm1.N2Click(Sender: TObject);
var

  F: TextFile;
  S: string;
  x,y : Integer;
begin

	if isChanged = true then
    begin

    	if(Application.MessageBox(
        	'vWFNg͕ۑĂ܂BvWFNgۑ܂H',
        	'',MB_YESNO) = IDYES ) then

    	SaveUpdateProject;

    end;

	//
    if OpenProjectDialog.Execute = False then Exit;

    AssignFile(F, OpenProjectDialog.Filename);
    Reset(F);

    Readln(F,LoadImagePath);
    Readln(F,ArrayName);

    Readln(F,s);
    Form2.Edit2.Text := s;
    Map_X := StrToInt(s);

    Readln(F,s);
    Form2.Edit3.Text := s;
    Map_Y := StrToInt(s);

    SetLength(MapTable,Map_Y,Map_X);
	ShowArraySize;

    for y := Low(MapTable) to High(MapTable) do
		for x := Low(MapTable[y]) to High(MapTable[y]) do
           Readln(F,MapTable[y][x]);


    CloseFile(F);

    ProjectFilePath := OpenProjectDialog.Filename;

    LoadImage;

    ChangeMapSizeX;
    ChangeMapSizeY;

	DrawGrid1.ColCount := Map_X + 1;
	DrawGrid1.RowCount := Map_Y + 1;

    DrawFrameTile;
    DrawGrid1.Repaint;

    isChanged := false;


end;

// vWFNg㏑ۑ
procedure TForm1.SaveUpdateProject;
var

  F: TextFile;
  S: string;
  x,y : Integer;

begin

    if ProjectFilePath = '' then
    begin
        if OpenProjectDialog.Execute = False then Exit;
        ProjectFilePath := OpenProjectDialog.Filename;
    end;


    AssignFile(F, ProjectFilePath);
    Rewrite(F);

    Writeln(F,LoadImagePath);

    Writeln(F,ArrayName);

    s := Form2.Edit2.Text;
    Writeln(F,s);

    s := Form2.Edit3.Text;
    Writeln(F,s);


    for y := Low(MapTable) to High(MapTable) do
		for x := Low(MapTable[y]) to High(MapTable[y]) do
           Writeln(F,MapTable[y][x]);


    CloseFile(F);

    isChanged := false;


end;

// ㏑ۑ
procedure TForm1.N3Click(Sender: TObject);
begin

    SaveUpdateProject;

end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
	DrawGrid1.Repaint;
end;

// vOI
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin


	if isChanged = true then
    begin

    	if(Application.MessageBox('vWFNg͕ۑĂ܂BvWFNgۑ܂H','',MB_YESNO) = IDYES ) then
    	SaveUpdateProject;

    end;

    Finalize(MapTable);

end;

// Iz̃TCY\
procedure TForm1.ShowArraySize;
var

	t : String;
	byte,L : Longint;

begin

	t := 'byte';
	byte := (2*Map_X*Map_Y);
    L := byte;

    if L > 10240 then
    begin
    	L := L div 1024;
        t := 'KB';
    end;
    if L > 10240 then
    begin
    	L := L div 1024;
        t := 'MB';
    end;
    if L > 10240 then
    begin
    	L := L div 1024;
        t := 'GB';
    end;

	Form2.Label14.Caption := IntToStr(L) + t + '(' + IntToStr(byte) + 'byte)';
    Form2.Label10.Caption := IntToStr(High(MapTable[0])+1) + ',' +IntToStr(High(MapTable)+1);

end;


procedure TForm1.N4Click(Sender: TObject);
begin

	if OpenPictureDialog1.Execute then
    begin
        LoadImagePath := OpenPictureDialog1.FileName;

        LoadImage;
        DrawFrameTile;
        DrawGrid1.Repaint;

    end;

end;

// ݒ_CAO\
procedure TForm1.Button5Click(Sender: TObject);
begin
        Form2.Show;
end;

// j[̏I
procedure TForm1.Exit1Click(Sender: TObject);
begin
    Application.Terminate;
end;

end.


