unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm2 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    RadioGroup1: TRadioGroup;
    Edit2: TEdit;
    Edit3: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Button1: TButton;
    SaveDialog1: TSaveDialog;
    Label14: TLabel;
    Label15: TLabel;
    Label10: TLabel;
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);

    // }bvf[^o
    procedure OutPutData;
    // Cz`Ń}bve[uo
    function Output_Carray : TStringList;
    // GAS`Ń}bve[uo
    function Output_GAS : TStringList;
    // DragonBASIC`Ń}bve[uo
    function Output_DragonBASIC : TStringList;

  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form2: TForm2;

implementation

uses Unit1;

{$R *.dfm}


// z񖼕ύX
procedure TForm2.Edit1Change(Sender: TObject);
begin
    Form1.ArrayName := Edit1.text;
    Form1.isChanged := true;
end;

// }bvXTCYύX
procedure TForm2.Edit2Change(Sender: TObject);
begin
    if Edit2.Text = '' then Edit2.Text := '1';
    Label6.Caption := IntToStr(StrToInt(Edit2.Text)*8);
    Form1.Map_X := StrToInt(Edit2.Text);
    Form1.ChangeMapSizeX;
    Form1.DrawGrid1.Repaint;
end;

// }bvYTCYύX
procedure TForm2.Edit3Change(Sender: TObject);
begin
    if Edit3.Text = '' then Edit3.Text := '1';
    Label7.Caption := IntToStr(StrToInt(Edit3.Text)*8);
    Form1.Map_Y := StrToInt(Edit3.Text);
    Form1.ChangeMapSizeY;
    Form1.DrawGrid1.Repaint;
end;

// tH[쐬
procedure TForm2.FormCreate(Sender: TObject);
begin
    Label6.Caption := IntToStr(StrToInt(Edit2.Text)*8);
    Label7.Caption := IntToStr(StrToInt(Edit3.Text)*8);
    Form1.ShowArraySize;
end;

// Cz`Ń}bve[uo
function TForm2.Output_Carray : TStringList;
var

  S,S1: string;
  TempList:TStrings;
  type1:string;

  x,y : Integer;

begin

  With Form1 do
  begin

    TempList := TStringList.Create;


    S1 := '';
    TempList.Add(S1);
    type1 := 'unsigned short'; // s16 -32767`+32767

    S1 := 'const ' + type1 + ' ' + ArrayName + '[] = {';
    TempList.Add(S1);
    S1 := '';
    TempList.Add(S1);
    S1 := '';

    for y := Low(MapTable) to High(MapTable) do
	begin
    	for x := Low(MapTable[y]) to High(MapTable[y]) do
        begin
        	S := IntToStr(MapTable[y][x]); //
     		S1 := S1 + S + ',';

     		if x mod 8 = 7 then
     		begin
     	    	TempList.Add(S1);
            	S1 := '';
     		end;
        end;

        TempList.Add(S1);
        S1 := '';
    end;

    S1 := '};';
    TempList.Add(S1);

    Result := TStringList.Create;
    Result.AddStrings(TempList);

    TempList.Free;

  end;

end;


// GAS`Ń}bve[uo
function TForm2.Output_GAS : TStringList;
var

  S,S1: string;
  TempList:TStrings;

  x,y : Integer;

begin

  With Form1 do
  begin

    TempList := TStringList.Create;


{	.global	bgdata
	.section .rodata
	.align	1
	.type	bgdata,object
	.size	bgdata,76800
bgdata:
	.short	19039
}

    TempList.Add(Chr(9) + '.global' + Chr(9) + ArrayName);
    TempList.Add(Chr(9) + '.section .rodata');
    TempList.Add(Chr(9) + '.align' + Chr(9) + '1');
    TempList.Add(Chr(9) + '.type' + Chr(9) + ArrayName + ',object');
    TempList.Add(Chr(9) + '.size' + Chr(9) + ArrayName + ',' + IntToStr(Map_X*Map_Y*2));
    TempList.Add(ArrayName + ':');


    TempList.Add(S1);
    S1 := '';

    for y := Low(MapTable) to High(MapTable) do
	begin
    	for x := Low(MapTable[y]) to High(MapTable[y]) do
        begin
        	S := IntToStr(MapTable[y][x]); //

            TempList.Add(Chr(9) + '.short' + Chr(9) + S);

        end;

    end;

    S1 := '';
    TempList.Add(S1);

    Result := TStringList.Create;
    Result.AddStrings(TempList);

    TempList.Free;

  end;

end;

// DragonBASIC`Ń}bve[uo
function TForm2.Output_DragonBASIC : TStringList;
var

  S,S1: string;
  TempList:TStrings;

  x,y : Integer;

begin

  With Form1 do
  begin

    TempList := TStringList.Create;

    S1 := ArrayName + ':';
    TempList.Add(S1);
    S1 := '';
    TempList.Add(S1);
    S1 := Chr(9) + 'data ';

    for y := Low(MapTable) to High(MapTable) do
	begin
    	for x := Low(MapTable[y]) to High(MapTable[y]) do
        begin
        	S := IntToStr(MapTable[y][x]); //

            if x = 0 then S1 := S1 + S
            else S1 := S1 + ',' + S;

        end;

        TempList.Add(S1);
        S1 := Chr(9) + 'data '; // ^u
    end;

    S1 := '';
    TempList.Add(S1);

    Result := TStringList.Create;
    Result.AddStrings(TempList);

    TempList.Free;

  end;

end;


// f[^o
procedure TForm2.OutPutData;
var
    i:Integer;
    F2:TextFile;
    TempList:TStringList;
begin

    // ރt@CɃANZX
    AssignFile(F2, SaveDialog1.Filename);
    Rewrite(F2);

    // ̕𐶐
    TempList := TStringList.Create;
    TempList.Clear;

    // TempList.Add('test');

    // Cz`ŏo
    if RadioGroup1.ItemIndex = 0 then
        TempList.AddStrings(OutPut_Carray)
    // GNU AS`ŏo
    else if RadioGroup1.ItemIndex = 1 then
        TempList.AddStrings(OutPut_GAS)
    // DragonBASIC`ŏo
    else if RadioGroup1.ItemIndex = 2 then
        TempList.AddStrings(OutPut_DragonBASIC);

    // t@CɂPs
    for i := 0 to TempList.Count-1 do
        Writeln(F2,TempList.Strings[i]);

    Flush(F2);

    CloseFile(F2);
    TempList.Free;

end;

// }bvf[^o
procedure TForm2.Button1Click(Sender: TObject);
begin

    SaveDialog1.FileName := Form1.ArrayName;

    if not SaveDialog1.Execute then Exit;

    OutPutData;

end;

end.
